'From Squeak3.8gamma of ''24 November 2004'' [latest update: #6643] on 11 April 2005 at 12:34:34 am'!
"Change Set:		MoreStringFixes
Date:			11 April 2005
Author:			Andreas Raab

Fixes a few more issues:
* Make String>>new: work properly without having to override it.
* Make sure all Strinngs hash equal if equal.
* Reclassify Strings under Collections-Text and move FilePath over to System-Files.
* Move two more methods up to String.
"!

Object subclass: #FilePath
	instanceVariableNames: 'squeakPathName vmPathName converter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Files'!
Character subclass: #MultiCharacter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Text'!
ArrayedCollection subclass: #String
	instanceVariableNames: ''
	classVariableNames: 'AsciiOrder CaseInsensitiveOrder CaseSensitiveOrder CSLineEnders CSNonSeparators CSSeparators HtmlEntities LowercasingTable Tokenish UppercasingTable'
	poolDictionaries: ''
	category: 'Collections-Text'!

!String commentStamp: '<historical>' prior: 0!
A String is an indexed collection of Characters. Class String provides the abstract super class for ByteString (that represents an array of 8-bit Characters) and MultiString (that represents an array of  32-bit MultiCharacters).  In the similar manner of LargeInteger and SmallInteger, those subclasses are chosen accordingly for a string; namely as long as the system can figure out so, the String is used to represent the given string.

Strings support a vast array of useful methods, which can best be learned by browsing and trying out examples as you find them in the code.

Here are a few useful methods to look at...
	String match:
	String contractTo:

String also inherits many useful methods from its hierarchy, such as
	SequenceableCollection ,
	SequenceableCollection copyReplaceAll:with:
!
]style[(55 382 188 13 2 18 72 24 2 44)f1,f2,f1,f1LString match:;,f1,f1LString contractTo:;,f1,f1LSequenceableCollection ,;,f1,f1LSequenceableCollection copyReplaceAll:with:;!


!ByteString commentStamp: '<historical>' prior: 0!
This class represents the array of 8 bit wide characters.
!

String variableWordSubclass: #MultiString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Text'!

!String methodsFor: 'comparing' stamp: 'ar 4/10/2005 22:39'!
hash
	"#hash is implemented, because #= is implemented"
	"ar 4/10/2005: I had to change this to use ByteString hash as initial 
	hash in order to avoid having to rehash everything and yet compute
	the same hash for ByteString and MultiString."
	^ self class stringHash: self initialHash: ByteString hash! !

!String methodsFor: 'converting' stamp: 'ar 4/10/2005 23:50'!
asMultiString 
	self isMultiString
		ifTrue:[^self]
		ifFalse:[^MultiString from: self]! !

!String methodsFor: 'testing' stamp: 'ar 4/10/2005 23:25'!
isOctetString
	"Answer whether the receiver can be represented as a byte string. 
	This is different from asking whether the receiver *is* a ByteString 
	(i.e., #isByteString)"
	1 to: self size do: [:pos |
		(self at: pos) asInteger >= 256 ifTrue: [^ false].
	].
	^ true.
! !


!String class methodsFor: 'instance creation' stamp: 'ar 4/10/2005 23:26'!
new: sizeRequested 
	"Answer an instance of this class with the number of indexable
	variables specified by the argument, sizeRequested."
	self == String 
		ifTrue:[^ByteString new: sizeRequested]
		ifFalse:[^self basicNew: sizeRequested].! !

MultiString class removeSelector: #new:!
ByteString class removeSelector: #new:!
MultiString removeSelector: #asMultiString!
MultiString removeSelector: #isOctetString!
